#!/bin/sh

set -e
. ./.common.sh

rm -Rf $DAHDI $DAHDI_ORIG
tar --no-same-owner -xf $DAHDI_ORIG.tar.gz
mv $DAHDI_ORIG $DAHDI

cd $DAHDIDIR/linux/include/dahdi/
patch < $BASEDIR/patches/kernel.h.patch
cd $DAHDIDIR/linux/drivers/dahdi/
patch < $BASEDIR/patches/dahdi-base.c.patch
patch < $BASEDIR/patches/dahdi-sysfs.c.patch
patch < $BASEDIR/patches/dahdi_dynamic.c.patch
patch < $BASEDIR/patches/dahdi_dynamic_eth.c.patch
patch < $BASEDIR/patches/dahdi_dummy.c.patch
cd $DAHDIDIR/linux

#
# Comment if you don't need OSLEC echo canceller
mkdir -p $DAHDIDIR/linux/drivers/staging/echo
cp -Rp $BASEDIR/oslec/. $DAHDIDIR/linux/drivers/staging/echo
sed -i "s|#ifdef CONFIG_DAHDI_MMX|#if defined (CONFIG_DAHDI_MMX) \&\& \!defined (CONFIG_X86_64)|" $DAHDIDIR/linux/drivers/dahdi/arith.h

# Uncomment to enable MMX optimization
#sed -i "s|/\* #define CONFIG_DAHDI_MMX \*/|#define CONFIG_DAHDI_MMX|" $DAHDIDIR/linux/include/dahdi/dahdi_config.h
#echo 'CFLAGS_echo.o += -DUSE_MMX' >> Kbuild
# Uncomment to enable SSE2 optimization
#sed -i "s|/\* #define CONFIG_DAHDI_MMX \*/|#define CONFIG_DAHDI_MMX|" $DAHDIDIR/linux/include/dahdi/dahdi_config.h
#echo 'CFLAGS_echo.o += -DUSE_SSE2' >> Kbuild

cd $BASEDIR
#Disable broked drivers, untill patch will be released.
sed -i "s|obj-\$(DAHDI_BUILD_ALL)\$(CONFIG_DAHDI_XPP)|#obj-\$(DAHDI_BUILD_ALL)\$(CONFIG_DAHDI_XPP)|" $DAHDI/linux/drivers/dahdi/Kbuild
sed -i "s|obj-\$(DAHDI_BUILD_ALL)\$(CONFIG_DAHDI_WCTE43X)|#obj-\$(DAHDI_BUILD_ALL)\$(CONFIG_DAHDI_WCTE43X)|" $DAHDI/linux/drivers/dahdi/Kbuild
# Disable loading Digium's firmware from website (we don't need it)
sed -i "s|prereq: include/dahdi/version.h firmware-loaders|prereq: include/dahdi/version.h|" $DAHDI/linux/Makefile
sed -i "s|install-firmware install-xpp-firm|install-include|" $DAHDI/linux/Makefile
# Uncomment to enable HDLC support
#sed -i "s|/\* #define CONFIG_DAHDI_NET \*/|#define CONFIG_DAHDI_NET|" $DAHDI/linux/include/dahdi/dahdi_config.h
# Uncomment to enable MIRROR
#sed -i "s|/\* #define CONFIG_DAHDI_MIRROR \*/|#define CONFIG_DAHDI_MIRROR|" $DAHDI/linux/include/dahdi/dahdi_config.h
# Uncomment to disable tasklet in dahdi_dynamic
#sed -i "s|#define ENABLE_TASKLETS|//#define ENABLE_TASKLETS|" $DAHDI/linux/drivers/dahdi/dahdi_dynamic.c
# Uncomment to enable short flash time - 60ms. Default: 200ms.
#sed -i "s|/\* #define SHORT_FLASH_TIME \*/|#define SHORT_FLASH_TIME|" $DAHDI/linux/include/dahdi/dahdi_config.h
# Uncommend to build dahdi_dummy
sed -i "s|#obj-\$(DAHDI_BUILD_ALL)\$(CONFIG_DAHDI_DUMMY)|obj-\$(DAHDI_BUILD_ALL)\$(CONFIG_DAHDI_DUMMY)|" $DAHDI/linux/drivers/dahdi/Kbuild
# Uncomment to extend DAHDI_MAX_CHANNELS to 4096
#sed -i "s|#define DAHDI_MAX_CHANNELS		1024|#define DAHDI_MAX_CHANNELS		4096|" $DAHDI/linux/include/dahdi/user.h
# Uncomment to enable DEBUG in DAHDI. Do not enable it !
#sed -i "s|/\* #define CONFIG_DAHDI_DEBUG \*/|#define CONFIG_DAHDI_DEBUG|" $DAHDI/linux/include/dahdi/dahdi_config.h
# Put any additional patches/commands here.
#editor $DAHDI/linux/include/dahdi/dahdi_config.h

cd $DAHDIDIR/linux
make $MAKEOPS

cd $BASEDIR
rm -rf quasar quasarm quasar-$QUASAR_VER  quasarm-$QUASARM_VER
tar --no-same-owner -xf quasar-$QUASAR_VER.tar.bz2

mv quasar-$QUASAR_VER quasar
make -C quasar $MAKEOPS $MODULEOPS

rm -rf dahdi_tdmox
tar --no-same-owner -xf dahdi_tdmox.tar.bz2
make -C dahdi_tdmox $MAKEOPS $MODULEOPS


echo "#################################################################"
echo "### You have built DAHDI kernel modules."
echo "### "
echo "### Build DAHDI tools with ./build.tools.sh ."
echo "#################################################################"
